"use strict";
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
Object.defineProperty(exports, "__esModule", { value: true });
var Access;
(function (Access) {
    Access["Explicit"] = "/*- explicit -*/";
    Access["Public"] = "public";
    Access["Internal"] = "internal";
    Access["Protected"] = "protected";
    Access["ProtectedInternal"] = "protected internal";
    Access["PrivateProtected"] = "private protected";
    Access["Private"] = "private";
    Access["Default"] = "";
})(Access = exports.Access || (exports.Access = {}));
var Modifier;
(function (Modifier) {
    Modifier["None"] = "";
    Modifier["Static"] = "static";
    Modifier["New"] = "new ";
    Modifier["ReadOnly"] = "readonly";
    Modifier["Volitile"] = "volitile";
    Modifier["Sealed"] = "sealed";
    Modifier["Override"] = "override";
    Modifier["Abstract"] = "abstract";
    Modifier["Extern"] = "extern";
    Modifier["Async"] = "async";
    Modifier["Virtual"] = "virtual";
})(Modifier = exports.Modifier || (exports.Modifier = {}));
const order = [Access.Public, Access.Internal, Access.Protected, Access.ProtectedInternal, Access.PrivateProtected, Access.Private, Access.Default];
function highestAccess(first, second) {
    if (first && second) {
        const f = order.indexOf(first);
        const s = order.indexOf(second);
        return f < s ? order[f] : order[s];
    }
    return first ? first : second;
}
exports.highestAccess = highestAccess;
function lowestAccess(first, second) {
    const f = order.indexOf(first);
    const s = order.indexOf(second);
    return f > s ? order[f] : order[s];
}
exports.lowestAccess = lowestAccess;
//# sourceMappingURL=access-modifier.js.map