"use strict";
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
Object.defineProperty(exports, "__esModule", { value: true });
const codegen_1 = require("@azure-tools/codegen");
const expression_1 = require("../expression");
const statement_1 = require("./statement");
class UsingStatement extends statement_1.Statements {
    constructor(usingExpression, statements, objectInitializer) {
        super(statements);
        this.usingExpression = expression_1.toExpression(usingExpression);
        this.apply(objectInitializer);
    }
    get implementation() {
        return `
using( ${this.usingExpression.value} )
{
${codegen_1.indent(super.implementation)}
}`.trim();
    }
}
exports.UsingStatement = UsingStatement;
function Using(usingExpression, body, objectInitializer) {
    return new UsingStatement(usingExpression, body, objectInitializer);
}
exports.Using = Using;
//# sourceMappingURL=using.js.map